function bound = func_doc_bound( s_marg, p_marg, A_0, A, tau, Eln_u, Eln_1_u,...
                                lambda_d, tau_d, prob_l, Eln_w, Eln_nu, cnts )
    ntopic = size(s_marg,1);
    N_d = size(prob_l,2);
    t_length = size(s_marg,2);
    s_marg = max(s_marg, 10^-50);
    for i=1:(t_length-1)
        p_marg{i} = max(p_marg{i}, 10^-50);
    end
    prob_l = max(prob_l, 10^-50);
    
    bound = sum(s_marg(:,1)'.*(psi(A_0)-psi(sum(A_0))));
    for i=1:(t_length-1)
        log_prob_z = p_marg{i}.*(psi(A)-repmat(psi(sum(A,2)),1,ntopic));
        bound = bound + sum(log_prob_z(:));
    end
    bound = bound - sum(s_marg(:,1).*log(s_marg(:,1)));
    for i=1:(t_length-1)
        cond_p_marg = p_marg{i}./repmat(s_marg(:,i),1,ntopic);
        entpy_qz = -p_marg{i}.*log(cond_p_marg);
        bound = bound + sum(entpy_qz(:));
    end
            
    log_prob_pu = log(gamma(1+tau)./gamma(1)./gamma(tau))...
       +(1-1).*Eln_u + (tau-1).*Eln_1_u;
    bound = bound + sum(log_prob_pu);
    entpy_qu = -(gammaln(lambda_d+tau_d)-gammaln(lambda_d)-gammaln(tau_d))...
       -(lambda_d-1).*Eln_u - (tau_d-1).*Eln_1_u;
    bound = bound + sum(entpy_qu);
    log_prob_pl = repmat(cnts,t_length,1).*prob_l.*repmat(Eln_nu,1,N_d);
    bound = bound + sum(log_prob_pl(:));
    entpy_ql = -repmat(cnts,t_length,1).*prob_l.*log(prob_l);
    bound = bound + sum(entpy_ql(:));
    log_prob_w = s_marg*(repmat(cnts,t_length,1).*prob_l).*Eln_w;
    bound = bound + sum(log_prob_w(:));
end

