function [ s_marg, p_marg, sum_cond ] = func_forward_backward( single_pot, pair_pot )

    % single_pot{t} = phi(z_t);
    % pair_pot{t} = phi(z_{t-1},z_t)

    T = length(single_pot);
    state_num = length(single_pot{1});
    fb_alpha=[]; fb_beta=[]; fb_c=[];
    
    % forward step
    prod_single = single_pot{1}.*pair_pot{1};
    fb_c = [fb_c sum(prod_single)];
    fb_alpha = [fb_alpha prod_single/fb_c(end)];
    for t=2:T
        prod_single = single_pot{t}.*(fb_alpha(:,end)'*pair_pot{t})';
        fb_c = [fb_c sum(prod_single)];
        fb_alpha = [fb_alpha prod_single/fb_c(end)];
    end
    
    % backward step
    fb_beta = [ones(state_num,1) fb_beta];
    for t=(T-1):-1:1
        prod_single = 1/fb_c(t+1)*pair_pot{t+1}*(single_pot{t+1}.*fb_beta(:,1));
        fb_beta = [prod_single fb_beta];
    end
    
    % single marginals
    s_marg = fb_alpha.*fb_beta;
    % pair marginals
    p_marg=[]; cond_p_marg=[];sum_cond=zeros(state_num,state_num);
    for t=1:(T-1)
        p_marg{t} = 1/fb_c(t+1)*repmat(fb_alpha(:,t),1,state_num) .* pair_pot{t+1} .* ...
            repmat((single_pot{t+1}.*fb_beta(:,t+1))',state_num,1);
        cond_p_marg{t} = p_marg{t}./repmat(s_marg(:,t),1,state_num);
        %sum_cond = sum_cond + cond_p_marg{t};
        sum_cond = sum_cond + p_marg{t};
    end
end

